> This page is for Developers.

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://zuora.ferndocs.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://zuora.ferndocs.com/_mcp/server.

# Update a workflow

PATCH https://rest.test.zuora.com/workflows/{workflow_id}
Content-Type: application/json

Updates a specific workflow by its ID, which allows you to [configure the settings of a workflow](https://knowledgecenter.zuora.com/CE_Workflow/Using_Workflow/B_Configure_a_Workflow) via API.

### User Access Permission
You must be assigned the **Workflow Manage Access** permission to run this operation.


Reference: https://zuora.ferndocs.com/developers/api-reference/zuora-api/workflow/workflows/patch-update-workflow

## Authentication

- `Authorization` header (bearer token, required) — Use `Bearer {{token}}` in the `Authorization` header for authentication.

## Servers

- `https://rest.test.zuora.com` (US Developer & Central Sandbox (incl. Test Drive), default)
- `https://rest.sandbox.na.zuora.com` (US API Sandbox Cloud 1)
- `https://rest.apisandbox.zuora.com` (US API Sandbox Cloud 2)
- `https://rest.na.zuora.com` (US Production Cloud 1)
- `https://rest.zuora.com` (US Production Cloud 2)
- `https://rest.test.eu.zuora.com` (EU Developer & Central Sandbox)
- `https://rest.sandbox.eu.zuora.com` (EU API Sandbox)
- `https://rest.eu.zuora.com` (EU Production)
- `https://rest.test.ap.zuora.com` (APAC Developer & Central Sandbox)
- `https://rest.ap.zuora.com` (APAC Production)

## Request

### Path parameters

- `workflow_id` (string, required) — The unique ID of a workflow definition. For example, 19080.

### Headers

- `Idempotency-Key` (string, optional) — Specify a unique idempotency key if you want to perform an idempotent POST or PATCH request. Do not use this header in other request types. With this header specified, the Zuora server can identify subsequent retries of the same request using this value, which prevents the same operation from being performed multiple times by accident.
- `Accept-Encoding` (string, optional) — Include the `Accept-Encoding: gzip` header to compress responses as a gzipped file. It can significantly reduce the bandwidth required for a response. If specified, Zuora automatically compresses responses that contain over 1000 bytes of data, and the response contains a `Content-Encoding` header with the compression algorithm so that your client can decompress it.
- `Content-Encoding` (string, optional) — Include the `Content-Encoding: gzip` header to compress a request. With this header specified, you should upload a gzipped file for the request payload instead of sending the JSON payload.
- `Zuora-Track-Id` (string, optional) — A custom identifier for tracing the API call. If you set a value for this header, Zuora returns the same value in the response headers. This header enables you to associate your system process identifiers with Zuora API calls, to assist with troubleshooting in the event of an issue. The value of this field must use the US-ASCII character set and must not include any of the following characters: colon (`:`), semicolon (`;`), double quote (`"`), and quote (`'`).
- `Zuora-Entity-Ids` (string, optional) — An entity ID. If you have [Zuora Multi-entity](https://knowledgecenter.zuora.com/BB_Introducing_Z_Business/Multi-entity) enabled and the OAuth token is valid for more than one entity, you must use this header to specify which entity to perform the operation in. If the OAuth token is only valid for a single entity, or you do not have Zuora Multi-entity enabled, you should not set this header.
- `Zuora-Org-Ids` (string, optional) — Comma separated IDs. If you have Zuora Multi-Org enabled, you can use this header to specify which orgs to perform the operation in. If you do not have Zuora Multi-Org enabled, you should not set this header. The IDs must be a sub-set of the user's accessible orgs. If you specify an org that the user does not have access to, the operation fails. This header is important in Multi-Org (MO) setups because it defines the organization context under which the API should operate—mainly used for read access or data visibility filtering. If the header is not set, the operation is performed in scope of the user's accessible orgs.

### Body (application/json)

This endpoint expects an object.

- `active_workflow_version_id` (integer, optional) — The id of a version. This version will then be set to the active version of the workflow definition.
- `description` (string, optional) — The description of the workflow defintion
- `name` (string, optional) — The name of the workflow definition
- `status` (string, optional) — Can be `Active` or `Inactive`. Active workfow definitions run like normal. Inactive workflow definitions cannot be run.

## Response

### 200

OK

- `active_version` (WorkflowDefinitionActiveVersion, optional) — Information of the active version.
- `calloutTrigger` (boolean, optional) — Indicates whether the callout trigger is enabled for the retrieved workflow.
- `createdAt` (string, optional) — The date and time when the workflow is created, in the `YYYY-MM-DD HH:MM:SS` format.
- `description` (string, optional) — The description of the workflow definition.
- `id` (integer, optional) — The unique ID of the workflow definition.
- `interval` (string, optional) — The schedule of the workflow, in a CRON expression. Returns null if the schedued trigger is disabled.
- `name` (string, optional) — The name of the workflow definition.
- `ondemandTrigger` (boolean, optional) — Indicates whether the ondemand trigger is enabled for the workflow.
- `scheduledTrigger` (boolean, optional) — Indicates whether the scheduled trigger is enabled for the workflow.
- `status` (string, optional) — The status of the workflow definition.
- `timezone` (string, optional) — The timezone that is configured for the scheduler of the workflow. Returns null if the scheduled trigger is disabled.
- `updatedAt` (string, optional) — The date and time when the workflow is updated the last time, in the `YYYY-MM-DD HH:MM:SS` format.

## Errors

### 404 Not Found Error

The workflow for the given id does not exist

- `Errors` (list of string, optional) — The error messages

### 422 Unprocessable Entity Error

Bad Request for one of the following reasons: * The name or description fields are not strings. * The ondemand_trigger, callout_trigger, or scheduled_trigger fields are not booleans. * The timezone does not match one of the valid values in [this spread sheet](https://docs.google.com/spreadsheets/d/1skhepi-q5l9LyaMUPZjU_V9gzTphNMqNyV6ST5mygEo/edit?usp=sharing). * The priority is not one of High, Medium, or Low. * The status is not one of Active or Inactive. * The scheduled_trigger is set to true but a valid timezone and interval were not passed.

- `reasons` (list of ValidationReasons, optional) — The list of reasons that the request was unsuccessful
- `success` (boolean, optional) — Returns `false` if the request was not successful.

## Types

### WorkflowDefinitionActiveVersion

Information of the active version.

- `description` (string, optional) — The description of the active version.
- `id` (integer, optional) — The unique ID of the active version.
- `status` (string, optional) — The status of the active version.
- `type` (enum, optional) — The type of the active version. Currently the only valid value is 'Workflow::Setup'.
  - Allowed values: `Workflow::Setup`, `Workflow::Instance`
- `version` (string, optional) — The version number of the active version.

### ValidationReasons

- `fieldName` (string, optional) — The name of the invalid field
- `title` (string, optional) — A description why that field is invalid

## Examples

**Request**

```json
{
  "description": "Retrieve and update products"
}
```

**Response**

```json
{
  "active_version": {
    "description": "the first description",
    "id": 265,
    "status": "Active",
    "type": "Workflow::Setup",
    "version": "0.0.1"
  },
  "calloutTrigger": true,
  "createdAt": "2021-02-04T13:39:10.530+08:00",
  "description": "Retrieve and update products",
  "id": 265,
  "name": "Refresh products",
  "ondemandTrigger": true,
  "scheduledTrigger": false,
  "status": "Active",
  "updatedAt": "2021-07-23T11:43:48.576+08:00"
}
```

**SDK Code**

```python response
import requests

url = "https://rest.test.zuora.com/workflows/workflow_id"

payload = { "description": "Retrieve and update products" }
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.patch(url, json=payload, headers=headers)

print(response.json())
```

```javascript response
const url = 'https://rest.test.zuora.com/workflows/workflow_id';
const options = {
  method: 'PATCH',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: '{"description":"Retrieve and update products"}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go response
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://rest.test.zuora.com/workflows/workflow_id"

	payload := strings.NewReader("{\n  \"description\": \"Retrieve and update products\"\n}")

	req, _ := http.NewRequest("PATCH", url, payload)

	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby response
require 'uri'
require 'net/http'

url = URI("https://rest.test.zuora.com/workflows/workflow_id")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Patch.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"description\": \"Retrieve and update products\"\n}"

response = http.request(request)
puts response.read_body
```

```java response
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.patch("https://rest.test.zuora.com/workflows/workflow_id")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{\n  \"description\": \"Retrieve and update products\"\n}")
  .asString();
```

```php response
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('PATCH', 'https://rest.test.zuora.com/workflows/workflow_id', [
  'body' => '{
  "description": "Retrieve and update products"
}',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp response
using RestSharp;

var client = new RestClient("https://rest.test.zuora.com/workflows/workflow_id");
var request = new RestRequest(Method.PATCH);
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"description\": \"Retrieve and update products\"\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift response
import Foundation

let headers = [
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = ["description": "Retrieve and update products"] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://rest.test.zuora.com/workflows/workflow_id")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "PATCH"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```